<script setup lang="ts">
  import type { CmsElementBuyBox } from '@shopware-pwa/composables-next';
  import { useCmsElementConfig } from '@shopware-pwa/composables-next';
  import { getProductName, getTranslatedProperty } from '@shopware-pwa/helpers-next';
  import { Product } from '@shopware-pwa/types';
  import { CmsPageProductDetailKey } from '~/helpers/injection';
  import { ShopPage } from '~/logic/interfaces/models/shopPages';

  const props = defineProps<{
    content: CmsElementBuyBox;
  }>();
  const productShared = inject(CmsPageProductDetailKey);
  const { getConfigValue } = useCmsElementConfig(props.content);
  const alignment = computed(() => getConfigValue('alignment'));

  const { taxState } = useSessionContext();

  const { product, changeVariant } = useProduct(
    props.content.data.product,
    props.content.data.configuratorSettings || [],
  );
  const { addToCart, loading: loadingAddToCart } = useAddToCart(product);
  const { controlledClient, permissionGranted } = useParticipants();

  const productId = computed<string>(() => product.value.id);
  const { isLiked, loading: loadingLike, toggleLike } = useLikeItem(productId);
  const { isGuide, isClient } = useUser();
  const { openShopPage } = useShopPage();
  const productDetailsModalController = useModal();

  const minPurchase = computed(() => product.value?.minPurchase ?? 1);
  const maxPurchase = computed(() => product.value?.maxPurchase ?? undefined);
  const purchaseSteps = computed(() => product.value?.purchaseSteps ?? 1);
  const packUnit = computed(() => getTranslatedProperty(product.value, 'packUnit'));
  const packUnitPlural = computed(() => getTranslatedProperty(product.value, 'packUnitPlural'));
  const quantity = ref(minPurchase.value);

  const openProductDetailsModal = () => {
    productDetailsModalController.open({
      productId: product.value.id,
      parentId: product.value.parentId,
    });
  };

  const handleAddToCart = async () => {
    await addToCart(quantity.value);
    quantity.value = minPurchase.value;
  };

  const handleChangeVariant = (product: Product) => {
    changeVariant(product);
    quantity.value = minPurchase.value;
  };

  watch(
    product,
    () => {
      if (!productShared) return;
      productShared.value = product.value;
    },
    {
      immediate: true,
    },
  );
</script>
<template>
  <div
    v-if="product"
    :class="{
      'flex h-full flex-col': true,
      'justify-start': alignment === 'flex-start',
      'justify-end': alignment === 'flex-end',
      'justify-center': alignment === 'center',
    }"
  >
    <slot name="product-badge">
      <ProductBadge :product="product" class="mb-4" />
    </slot>
    <h1 class="mb-7 md:mb-10 lg:mb-14">{{ getProductName({ product }) }}</h1>
    <div class="flex flex-col gap-8">
      <div name="product-meta" class="flex flex-col gap-2">
        <ProductPrice :product="product" />
        <span
          class="text-(sm primary) cursor-pointer font-medium"
          @click="openShopPage(ShopPage.SHIPPING)"
        >
          {{ $t('star') }}
          {{ taxState === 'gross' ? $t('product.includeTaxInfo') : $t('product.excludeTaxInfo') }}
        </span>
        <ProductDeliveryInformation :product="product" />
      </div>
      <div name="product-variant">
        <ProductVariantConfigurator :product="product" @change="handleChangeVariant" />
      </div>
      <div name="product-action">
        <div class="flex flex-col gap-3">
          <div
            v-if="isClient || (controlledClient && permissionGranted)"
            class="flex flex-row"
            :class="packUnit || packUnitPlural ? 'gap-15' : 'gap-3'"
          >
            <SwQuantitySelector
              v-model="quantity"
              :class="packUnit || packUnitPlural ? 'w-40' : 'w-30'"
              :min-purchase="minPurchase"
              :max-purchase="maxPurchase"
              :purchase-steps="purchaseSteps"
              :pack-unit="quantity === 1 ? packUnit : packUnitPlural"
            />
            <SwButton
              size="large"
              class="flex-1"
              :disabled="loadingAddToCart"
              :loading="loadingAddToCart"
              @click="handleAddToCart"
            >
              {{ $t('product.buyButton') }}
            </SwButton>
          </div>
          <SwButton
            v-if="isClient || controlledClient"
            size="large"
            variant="action"
            class="h-10 w-full"
            :disabled="loadingLike"
            :loading="loadingLike"
            @click="toggleLike"
          >
            <template #icon>
              <span :class="['i-sw-solid:heart text-sm', { 'text-crimson-500': isLiked }]" />
            </template>
            <template #default>
              {{ isLiked ? $t('product.removedFromWishlist') : $t('product.addToWishlist') }}
            </template>
          </SwButton>
        </div>
      </div>
      <div name="product-detail" class="space-2 flex flex-col">
        <p class="text-(xs information-dark)">
          <span class="font-medium">{{ $t('product.productNumber') }}</span
          >: {{ product?.productNumber }}
        </p>
        <SwButton
          v-if="isGuide"
          class="mt-4 w-fit"
          variant="action"
          @click.prevent="openProductDetailsModal()"
        >
          <template #icon>
            <span class="i-sw-solid:receipt mr-1 text-base/none"></span>
          </template>
          <span class="text-sm/none">{{ $t('product.productDetails') }}</span>
        </SwButton>
      </div>
    </div>
    <ProductDetailsModal
      v-if="isGuide && productDetailsModalController.isOpen.value"
      :controller="productDetailsModalController"
      :data="productDetailsModalController.data.value"
    />
  </div>
</template>
